/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of Client.xs. Do not edit this file, edit Client.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/WebSphere/MQTT/Client.xs"
/*

	WebSphere MQ Telemetry Transport
	Perl Interface to IA93

	Nicholas Humfrey
	University of Southampton
	njh@ecs.soton.ac.uk
	
*/

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

/* WMQTT include */
#include "MQIsdp.h"
#include "ppersist.h"



/* Get the connection handle from hashref */
MQISDPCH
get_handle_from_hv( HV* hash ) {
	SV** svp = NULL;
	IV pointer;
	
	svp = hv_fetch( hash, "handle", 6, 0 );
	if (svp == NULL || !SvOK(*svp)) {
		warn("Connection handle is missing from hash");
		return NULL;
	}
	
	if (!sv_derived_from(*svp, "MQISDPCH")) {
		//warn("Connection handle isn't isn't of type MQISDPCH");
		return NULL;
	}

	// Re-reference and extract the pointer
	pointer = SvIV((SV*)SvRV(*svp));
	return INT2PTR(MQISDPCH,pointer);
}


/* Get debug settings from hashref */
int
get_debug_from_hv( HV* hash ) {
	SV** svp = NULL;
	
	svp = hv_fetch( hash, "debug", 5, 0 );
	if (svp == NULL) {
		warn("Debug setting is missing from hash");
		return 0;
	}
	
	return SvTRUE( *svp );
}


/* Get task info from hashref */
MQISDPTI*
get_task_info_from_hv( HV* hash, char* name ) {
	SV** svp = NULL;
	IV pointer;
	
	svp = hv_fetch( hash, name, strlen(name), 0 );
	if (svp == NULL || !SvOK(*svp)) return NULL;
	if (!sv_derived_from(*svp, "MQISDPTIPtr")) return NULL;

	// Re-reference and extract the pointer
	pointer = SvIV((SV*)SvRV(*svp));
	return INT2PTR(MQISDPTI*,pointer);
}


/* Undefine the value of a key */
void
hv_key_undef( HV* hash, char* key ) {
	SV** svp = NULL;

	svp = hv_fetch( hash, key, strlen(key), 0 );
	if (svp) {
		sv_setsv(*svp, &PL_sv_undef);
	} /* else {
		warn("hv_key_undef: Didn't find key in hash");
	} */
}


/* Make an array from pubOptions */
AV*
options_to_av( long pubOptions ) {
	SV* sv = NULL;
	AV* av = newAV();
	
	if (pubOptions & MQISDP_WILL) {
		sv = newSVpv( "WILL", 0 );
		av_push( av, sv );
	}
	
	if (pubOptions & MQISDP_RETAIN) {
		sv = newSVpv( "RETAIN", 0 );
		av_push( av, sv );
	}
	
	if (pubOptions & MQISDP_QOS_0) {
		sv = newSVpv( "QOS_0", 0 );
		av_push( av, sv );
	}
	
	if (pubOptions & MQISDP_QOS_1) {
		sv = newSVpv( "QOS_1", 0 );
		av_push( av, sv );
	}
	
	if (pubOptions & MQISDP_QOS_2) {
		sv = newSVpv( "QOS_2", 0 );
		av_push( av, sv );
	}
	
	if (pubOptions & MQISDP_CLEAN_START) {
		sv = newSVpv( "CLEAN_START", 0 );
		av_push( av, sv );
	}
	
	if (pubOptions & MQISDP_WILL_RETAIN) {
		sv = newSVpv( "WILL_RETAIN", 0 );
		av_push( av, sv );
	}
	
	if (pubOptions & MQISDP_DUPLICATE) {
		sv = newSVpv( "DUPLICATE", 0 );
		av_push( av, sv );
	}

	return av;
}



#define STATUS_CASE_RET( x ) \
  case x:           \
    return #x;    \
    break;


const char*
get_status_string( int statusCode ) {

 	switch(statusCode) {
		case MQISDP_OK:						return "OK";
		case MQISDP_PROTOCOL_VERSION_ERROR:	return "PROTOCOL_VERSION_ERROR";
		case MQISDP_HOSTNAME_NOT_FOUND:		return "HOSTNAME_NOT_FOUND";
		case MQISDP_Q_FULL:					return "Q_FULL";
		case MQISDP_FAILED:					return "FAILED";
		case MQISDP_PUBS_AVAILABLE:			return "PUBS_AVAILABLE";
		case MQISDP_NO_PUBS_AVAILABLE:		return "NO_PUBS_AVAILABLE";
		case MQISDP_PERSISTENCE_FAILED:		return "PERSISTENCE_FAILED";
		case MQISDP_CONN_HANDLE_ERROR:		return "CONN_HANDLE_ERROR";
		case MQISDP_NO_WILL_TOPIC:			return "NO_WILL_TOPIC";
		case MQISDP_INVALID_STRUC_LENGTH:	return "INVALID_STRUC_LENGTH";
		case MQISDP_DATA_LENGTH_ERROR:		return "DATA_LENGTH_ERROR";
		case MQISDP_DATA_TOO_BIG:			return "DATA_TOO_BIG";
		case MQISDP_ALREADY_CONNECTED:		return "ALREADY_CONNECTED";
		case MQISDP_CONNECTION_BROKEN:		return "CONNECTION_BROKEN";
		case MQISDP_DATA_TRUNCATED:			return "DATA_TRUNCATED";
		case MQISDP_CLIENT_ID_ERROR:		return "CLIENT_ID_ERROR";
		case MQISDP_BROKER_UNAVAILABLE:		return "BROKER_UNAVAILABLE";
		case MQISDP_SOCKET_CLOSED:			return "SOCKET_CLOSED";
		case MQISDP_OUT_OF_MEMORY:			return "OUT_OF_MEMORY";
 		
		case MQISDP_DELIVERED:				return "DELIVERED";
		case MQISDP_RETRYING:				return "RETRYING";
		case MQISDP_IN_PROGRESS:			return "IN_PROGRESS";
		case MQISDP_MSG_HANDLE_ERROR:		return "MSG_HANDLE_ERROR";
		
		case MQISDP_CONNECTING:				return "CONNECTING";
		case MQISDP_CONNECTED:				return "CONNECTED";
		case MQISDP_DISCONNECTED:			return "DISCONNECTED";
	}
	
	return "UNKNOWN";
}


#line 196 "lib/WebSphere/MQTT/Client.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 340 "lib/WebSphere/MQTT/Client.c"

XS_EUPXS(XS_WebSphere__MQTT__Client_xs_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_WebSphere__MQTT__Client_xs_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 195 "lib/WebSphere/MQTT/Client.xs"
   MQIsdp_version();
#line 351 "lib/WebSphere/MQTT/Client.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_WebSphere__MQTT__Client_xs_start_tasks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_WebSphere__MQTT__Client_xs_start_tasks)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	HV*	self;
#line 205 "lib/WebSphere/MQTT/Client.xs"
  	MQISDPTI* pSendTaskInfo = NULL;
  	MQISDPTI* pRcvTaskInfo = NULL;
  	MQISDPTI* pApiTaskInfo = NULL;
  	char *clientid = NULL;
  	SV** svp = NULL;
 	SV* sv = NULL;

#line 373 "lib/WebSphere/MQTT/Client.c"
	int	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    self = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"WebSphere::MQTT::Client::xs_start_tasks",
				"self");
		}
	} STMT_END
;
#line 213 "lib/WebSphere/MQTT/Client.xs"
  	/* Get the client ID */
  	svp = hv_fetch( self, "clientid", 8, 0 );
  	if (svp != NULL) {
  		clientid = SvPV_nolen( *svp );
  		if (strlen(clientid) < 1 || strlen(clientid) > 23) {
  			croak("clientid is not valid");
  		}
  	} else {
  		croak("clientid is not defined");
   	}


	/* Allocate the WMQTT thread parameter structures */
	pSendTaskInfo = (MQISDPTI*)malloc( sizeof(MQISDPTI) );
	pRcvTaskInfo = (MQISDPTI*)malloc( sizeof(MQISDPTI) );
	pApiTaskInfo = (MQISDPTI*)malloc( sizeof(MQISDPTI) );

	/* Zero the memory */
	bzero( pSendTaskInfo, sizeof(MQISDPTI) );
	bzero( pRcvTaskInfo, sizeof(MQISDPTI) );
	bzero( pApiTaskInfo, sizeof(MQISDPTI) );

	/* Turn thread tracing off */
	pSendTaskInfo->logLevel = LOGNONE;
	pRcvTaskInfo->logLevel = LOGNONE;
	pApiTaskInfo->logLevel = LOGNONE;


	/* Start the threads (if enabled) */
	if ( MQIsdp_StartTasks( pApiTaskInfo, pSendTaskInfo,
                            pRcvTaskInfo, clientid ) != 0 ) {
        croak("Failed to start MQIsdp protocol threads");
        XSRETURN_UNDEF;
    }

    /* Store thread parameter pointers */
	sv=sv_setref_pv(newSV(0), "MQISDPTIPtr", (void *)pSendTaskInfo);
	if (hv_store(self, "send_task_info", 14, sv, 0) == NULL) {
		croak("send_task_info not stored");
	}

	sv=sv_setref_pv(newSV(0), "MQISDPTIPtr", (void *)pRcvTaskInfo);
	if (hv_store(self, "recv_task_info", 14, sv, 0) == NULL) {
		croak("recv_task_info not stored");
	}

	sv=sv_setref_pv(newSV(0), "MQISDPTIPtr", (void *)pApiTaskInfo);
	if (hv_store(self, "api_task_info", 13, sv, 0) == NULL) {
		croak("api_task_info not stored");
	}


    /* Successful */
    RETVAL = 1;

#line 446 "lib/WebSphere/MQTT/Client.c"
	ST(0) = newRV((SV*)self);
	SvSETMAGIC(ST(0));
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_WebSphere__MQTT__Client_xs_status); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_WebSphere__MQTT__Client_xs_status)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	HV*	self;
#line 282 "lib/WebSphere/MQTT/Client.xs"
  	MQISDPCH	handle = MQISDP_INV_CONN_HANDLE;
	int			statusCode=0;
	int			debug=0;
	char        infoString[MQISDP_INFO_STRING_LENGTH] = "";
	const char	*statusString = NULL;

#line 471 "lib/WebSphere/MQTT/Client.c"
	const char *	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    self = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"WebSphere::MQTT::Client::xs_status",
				"self");
		}
	} STMT_END
;
#line 289 "lib/WebSphere/MQTT/Client.xs"
  	/* get the connection handle */
  	handle = get_handle_from_hv( self );  
  	debug = get_debug_from_hv( self );

  	/* Not connected ? */
  	if (handle == NULL) {
  		statusCode = MQISDP_DISCONNECTED;
  	} else {
		/* get the connection status */
		statusCode = MQIsdp_status( handle, MQISDP_RC_STRING_LENGTH, NULL, infoString );
 	}

 	/* Turn status code into a string */
 	statusString = get_status_string( statusCode );
 	if (debug) {
 		fprintf(stderr, "xs_status: %s [%d] - %s\n", statusString, statusCode, infoString);
 	}

	RETVAL = statusString;

#line 509 "lib/WebSphere/MQTT/Client.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_WebSphere__MQTT__Client_xs_connect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_WebSphere__MQTT__Client_xs_connect)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, pApiTaskInfo");
    {
	HV*	self;
	MQISDPTI *	pApiTaskInfo;
#line 324 "lib/WebSphere/MQTT/Client.xs"
  	CONN_PARMS	*pCp = NULL;
  	MQISDPCH	handle = MQISDP_INV_CONN_HANDLE;
  	long        connMsgLength = 0;
  	SV**		svp = NULL;
 	SV*			sv = NULL;
 	int			rc = MQISDP_FAILED;

#line 535 "lib/WebSphere/MQTT/Client.c"
	const char *	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    self = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"WebSphere::MQTT::Client::xs_connect",
				"self");
		}
	} STMT_END
;

	if (SvROK(ST(1)) && sv_derived_from(ST(1), "MQISDPTIPtr")) {
	    IV tmp = SvIV((SV*)SvRV(ST(1)));
	    pApiTaskInfo = INT2PTR(MQISDPTI *,tmp);
	}
	else {
		const char* refstr = SvROK(ST(1)) ? "" : SvOK(ST(1)) ? "scalar " : "undef";
	    Perl_croak_nocontext("%s: Expected %s to be of type %s; got %s%" SVf " instead",
			"WebSphere::MQTT::Client::xs_connect",
			"pApiTaskInfo", "MQISDPTIPtr",
			refstr, ST(1)
		);
	}
;
#line 332 "lib/WebSphere/MQTT/Client.xs"
  	/* length of Connect Messgae */
	connMsgLength = sizeof(CONN_PARMS);

	/* Create Connect data structure */
	pCp = (CONN_PARMS*)malloc( connMsgLength );
	pCp->strucLength = connMsgLength;



    /* Fill out parameters from hashref */
    svp = hv_fetch( self, "clientid", 8, 0 );
    if (svp && SvPOK(*svp))	strcpy( pCp->clientId, SvPV_nolen(*svp) );
	else		croak("'clientid' setting isn't available");

    svp = hv_fetch( self, "retry_count", 11, 0 );
    if (svp && SvIOK(*svp))	pCp->retryCount = SvIV(*svp);
	else		croak("'retry_count' setting isn't available");

    svp = hv_fetch( self, "retry_interval", 14, 0 );
    if (svp && SvIOK(*svp))	pCp->retryInterval = SvIV(*svp);
	else		croak("'retry_interval' setting isn't available");

    svp = hv_fetch( self, "keep_alive", 10, 0 );
    if (svp && SvIOK(*svp))	pCp->keepAliveTime = SvIV(*svp);
	else		croak("'keep_alive' setting isn't available");

    svp = hv_fetch( self, "host", 4, 0 );
    if (svp && SvPOK(*svp))	pCp->brokerHostname = SvPV_nolen(*svp);
	else		croak("'host' setting isn't available");

    svp = hv_fetch( self, "port", 4, 0 );
    if (svp && SvIOK(*svp))	pCp->brokerPort = SvIV(*svp);
	else		croak("'port' setting isn't available");

    svp = hv_fetch( self, "persist", 7, 0 );
    if (svp && SvOK(*svp)) {
		if (sv_isobject(*svp)) {
			pCp->pPersistFuncs = new_persistence_wrapper(*svp);
			sv=sv_setref_pv(newSV(0), "MQISDPTIPtr", (void *)pCp->pPersistFuncs);
			if (hv_store(self, "persist_info", 12, sv, 0) == NULL) {
				croak("persist_info not stored");
			}
		}
		else	croak("'persist' setting must be an object");
    }
    else	pCp->pPersistFuncs = NULL;

	/* Set options flags */
	pCp->options = MQISDP_NONE;
	svp = hv_fetch( self, "clean_start", 11, 0 );
	if (svp) {
		if (SvIV(*svp)) pCp->options |= MQISDP_CLEAN_START;
	} else {
		croak("'clean_start' setting isn't available");
	}

	/* Perform the connect */
	rc = MQIsdp_connect( &handle, pCp, pApiTaskInfo );
	free( pCp );


    /* Store connection handle pointer */
	sv=sv_setref_pv(newSV(0), "MQISDPCH", (void *)handle);
	if (hv_store(self, "handle", 6, sv, 0) == NULL) {
		croak("connection handle not stored");
	}

	/* Return result code as a string */
	RETVAL = get_status_string( rc );

#line 637 "lib/WebSphere/MQTT/Client.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_WebSphere__MQTT__Client_xs_disconnect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_WebSphere__MQTT__Client_xs_disconnect)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	HV*	self;
#line 415 "lib/WebSphere/MQTT/Client.xs"
   	MQISDPCH	handle = MQISDP_INV_CONN_HANDLE;
 	int			rc = MQISDP_FAILED;

#line 658 "lib/WebSphere/MQTT/Client.c"
	const char *	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    self = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"WebSphere::MQTT::Client::xs_disconnect",
				"self");
		}
	} STMT_END
;
#line 419 "lib/WebSphere/MQTT/Client.xs"
  	/* get the connection handle */
  	handle = get_handle_from_hv( self );  	

	if (handle) {  	
  		/* perform the disconnect */
  		rc = MQIsdp_disconnect( &handle );

  		/* Undef 'handle' if its value now NULL */
  		if (handle==MQISDP_INV_CONN_HANDLE) hv_key_undef( self, "handle" );
	}

  	RETVAL = get_status_string( rc );

#line 689 "lib/WebSphere/MQTT/Client.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_WebSphere__MQTT__Client_xs_terminate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_WebSphere__MQTT__Client_xs_terminate)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	HV*	self;
#line 445 "lib/WebSphere/MQTT/Client.xs"
#line 707 "lib/WebSphere/MQTT/Client.c"
	const char *	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    self = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"WebSphere::MQTT::Client::xs_terminate",
				"self");
		}
	} STMT_END
;
#line 446 "lib/WebSphere/MQTT/Client.xs"
  	MQISDPTI *pApiTaskInfo = get_task_info_from_hv( self, "api_task_info" );
  	MQISDPTI *pSendTaskInfo = get_task_info_from_hv( self, "send_task_info" );
  	MQISDPTI *pRcvTaskInfo = get_task_info_from_hv( self, "recv_task_info" );
  	MQISDPTI *pPersistInfo = get_task_info_from_hv( self, "persist_info" );

  	/* Free the memory */
  	if (pApiTaskInfo) free( pApiTaskInfo );
  	if (pSendTaskInfo) free( pSendTaskInfo );
  	if (pRcvTaskInfo) free( pRcvTaskInfo );
	if (pPersistInfo) free( pPersistInfo );

	/* Undef them in the hash */
	hv_key_undef( self, "api_task_info");
	hv_key_undef( self, "send_task_info");
	hv_key_undef( self, "recv_task_info");
	hv_key_undef( self, "persist_info");

	/* Terminate threads and return result as a string */
  	RETVAL = get_status_string( MQIsdp_terminate() );

#line 745 "lib/WebSphere/MQTT/Client.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_WebSphere__MQTT__Client_xs_subscribe); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_WebSphere__MQTT__Client_xs_subscribe)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, topic, qos");
    {
	HV*	self;
	char*	topic = (char *)SvPV_nolen(ST(1))
;
	int	qos = (int)SvIV(ST(2))
;
#line 483 "lib/WebSphere/MQTT/Client.xs"
  	MQISDPCH	handle = MQISDP_INV_CONN_HANDLE;
  	MQISDPMH	hMsg = 0;
  	SUB_PARMS	*pSp = NULL;
	int			bufSize = 0;
	int			rc = 0;

#line 773 "lib/WebSphere/MQTT/Client.c"
	const char *	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    self = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"WebSphere::MQTT::Client::xs_subscribe",
				"self");
		}
	} STMT_END
;
#line 490 "lib/WebSphere/MQTT/Client.xs"
  	/* get the connection handle */
  	handle = get_handle_from_hv( self );  

	/* Allocate memory for stucture */
	bufSize = sizeof(SUB_PARMS) + (2 * sizeof(long)) + strlen(topic);
	pSp = (SUB_PARMS*)malloc( bufSize );

	if (pSp) {
		char	*pTmpPtr = NULL;
		long	options = 0;
		long	tLength = 0;

		pSp->strucLength = bufSize;

        /* Set the topic length field */
        pTmpPtr = (char*)pSp + sizeof(long);
        tLength = strlen(topic);
        memcpy( pTmpPtr, &tLength, sizeof(long) );

        /* Set the topic field */
        pTmpPtr += sizeof(long);
        memcpy( pTmpPtr, topic, strlen(topic) );

        /* Set the options field */
        pTmpPtr += strlen(topic);
        switch ( qos ) {
			case 0: options |= MQISDP_QOS_0; break;
			case 1: options |= MQISDP_QOS_1; break;
			case 2: options |= MQISDP_QOS_2; break;
        }
        memcpy( pTmpPtr, &options, sizeof(long) );

		/* Subscribe */
		rc = MQIsdp_subscribe( handle, &hMsg, pSp );
		free( pSp );

	} else {
		rc = MQISDP_OUT_OF_MEMORY;
	}

	RETVAL = get_status_string(rc);

#line 833 "lib/WebSphere/MQTT/Client.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_WebSphere__MQTT__Client_xs_unsubscribe); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_WebSphere__MQTT__Client_xs_unsubscribe)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, topic");
    {
	HV*	self;
	char*	topic = (char *)SvPV_nolen(ST(1))
;
#line 547 "lib/WebSphere/MQTT/Client.xs"
  	MQISDPCH	handle = MQISDP_INV_CONN_HANDLE;
  	MQISDPMH	hMsg = 0;
  	UNSUB_PARMS	*pUp = NULL;
	int			bufSize = 0;
	int			rc = 0;

#line 859 "lib/WebSphere/MQTT/Client.c"
	const char *	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    self = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"WebSphere::MQTT::Client::xs_unsubscribe",
				"self");
		}
	} STMT_END
;
#line 554 "lib/WebSphere/MQTT/Client.xs"
  	/* get the connection handle */
  	handle = get_handle_from_hv( self );  

	/* Allocate memory for stucture */
	bufSize = sizeof(UNSUB_PARMS) + sizeof(long) + strlen(topic);
	pUp = (UNSUB_PARMS*)malloc( bufSize );

	if (pUp) {
		char	*pTmpPtr = NULL;
		long	tLength = 0;

		pUp->strucLength = bufSize;

        /* Set the topic length field */
        pTmpPtr = (char*)pUp + sizeof(long);
        tLength = strlen(topic);
        memcpy( pTmpPtr, &tLength, sizeof(long) );

        /* Set the topic field */
        pTmpPtr += sizeof(long);
        memcpy( pTmpPtr, topic, strlen(topic) );

		/* Unsubscribe */
		rc = MQIsdp_unsubscribe( handle, &hMsg, pUp );
		free( pUp );

	} else {
		rc = MQISDP_OUT_OF_MEMORY;
	}

	RETVAL = get_status_string(rc);

#line 909 "lib/WebSphere/MQTT/Client.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_WebSphere__MQTT__Client_xs_receivePub); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_WebSphere__MQTT__Client_xs_receivePub)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	HV*	self;
#line 599 "lib/WebSphere/MQTT/Client.xs"
  	MQISDPCH	handle = MQISDP_INV_CONN_HANDLE;
  	HV			*hash = newHV();
  	SV			*sv = NULL;

	int			rc = 0;
	int			stillWaiting = 1;
	long		timeToWait = 10000;	// 10 Seconds

	long		dataLength = 0;
	long		topicLength = 0;
	long		pubOptions = 0;
	long		bufferSz = 1024;
	char		*pBuffer = NULL;


#line 942 "lib/WebSphere/MQTT/Client.c"
	HV *	RETVAL;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    self = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"WebSphere::MQTT::Client::xs_receivePub",
				"self");
		}
	} STMT_END
;
#line 615 "lib/WebSphere/MQTT/Client.xs"
  	/* get the connection handle */
  	handle = get_handle_from_hv( self );  


  	/* Allocate some memory to store messgae */
  	pBuffer = (char*)malloc( bufferSz );


  	/* Wait for a message */
  	while( stillWaiting )
	{

  		rc = MQIsdp_receivePub( handle, timeToWait, &pubOptions, &topicLength, &dataLength, bufferSz-1, pBuffer );

		/* Not sure why this is required */
		dataLength -= topicLength;

  		switch( rc ) {
  			case MQISDP_DATA_TRUNCATED:
  				bufferSz = dataLength+topicLength+1;
  				if (pBuffer == NULL) {
  					pBuffer = (char*)malloc( bufferSz );
  				} else {
  					pBuffer = (char*)realloc( pBuffer, bufferSz );
   				}
  			break;

  			case MQISDP_NO_PUBS_AVAILABLE:
  				/* Do nothing */
  			break;

  			case MQISDP_PUBS_AVAILABLE:
  			case MQISDP_OK:

   				/* Store the options */
   				sv = newRV_noinc((SV*)options_to_av( pubOptions ));
  				if (hv_store(hash, "options", 7, sv, 0) == NULL) {
					croak("xs_receivePub: options not stored");
				}

 				/* Store the topic length */
				sv=newSViv(topicLength);
				if (hv_store(hash, "topic_length", 12, sv, 0) == NULL) {
					croak("xs_receivePub: topic_length not stored");
				}

				/* Store the topic */
				sv=newSVpv(pBuffer, topicLength);
				if (hv_store(hash, "topic", 5, sv, 0) == NULL) {
					croak("xs_receivePub: topic not stored");
				}

				/* Store the data length */
				sv=newSViv(dataLength);
				if (hv_store(hash, "data_length", 8, sv, 0) == NULL) {
					croak("xs_receivePub: data_length not stored");
				}

				/* Store the data */
				sv=newSVpv(pBuffer+topicLength, dataLength);
				if (hv_store(hash, "data", 4, sv, 0) == NULL) {
					croak("xs_receivePub: data not stored");
				}

				/* FALLTHROUGH */

  			default:

				/* Store the status */
				sv=newSVpv(get_status_string(rc), 0);
				if (hv_store(hash, "status", 6, sv, 0) == NULL) {
					croak("xs_receivePub: status not stored");
				}

  				stillWaiting = 0;
  			break;
  		}

   	}


	/* Free the message buffer */
	if (pBuffer) free( pBuffer );

	RETVAL = hash;

#line 1045 "lib/WebSphere/MQTT/Client.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_WebSphere__MQTT__Client_xs_publish); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_WebSphere__MQTT__Client_xs_publish)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "self, data, topic, qos, retain");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	HV*	self;
	char*	data = (char *)SvPV_nolen(ST(1))
;
	char*	topic = (char *)SvPV_nolen(ST(2))
;
	int	qos = (int)SvIV(ST(3))
;
	int	retain = (int)SvIV(ST(4))
;
#line 720 "lib/WebSphere/MQTT/Client.xs"
  	MQISDPCH	handle = MQISDP_INV_CONN_HANDLE;
  	MQISDPMH	hMsg = MQISDP_INV_MSG_HANDLE;
  	PUB_PARMS	Pp;
	int		rc = 0;

#line 1081 "lib/WebSphere/MQTT/Client.c"

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    self = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"WebSphere::MQTT::Client::xs_publish",
				"self");
		}
	} STMT_END
;
#line 727 "lib/WebSphere/MQTT/Client.xs"
  	/* get the connection handle */
  	handle = get_handle_from_hv( self );

	Pp.strucLength = sizeof(PUB_PARMS);

	/* Set the options field */
	Pp.options = MQISDP_NONE;
	switch ( qos ) {
			case 0: Pp.options |= MQISDP_QOS_0; break;
			case 1: Pp.options |= MQISDP_QOS_1; break;
			case 2: Pp.options |= MQISDP_QOS_2; break;
	}
	if ( retain ) {
			Pp.options |= MQISDP_RETAIN;
	}

	/* Set the topic length field */
	Pp.topicLength = strlen(topic);

	/* Set the topic field */
	Pp.topic = topic;

	/* Set the data length field */
	Pp.dataLength = strlen(data);

	/* Set the data field */
	Pp.data = data;

	/* Publish */
	rc = MQIsdp_publish( handle, &hMsg, &Pp );

	/* Return two values as an array */	
	XPUSHs( sv_2mortal( newSVpv( get_status_string(rc), 0 ) ) );
	XPUSHs( sv_2mortal( newSVnv( hMsg ) ) );
#line 1131 "lib/WebSphere/MQTT/Client.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_WebSphere__MQTT__Client_xs_getMsgStatus); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_WebSphere__MQTT__Client_xs_getMsgStatus)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, hMsg");
    {
	HV*	self;
	long	hMsg = (long)SvIV(ST(1))
;
#line 773 "lib/WebSphere/MQTT/Client.xs"
  	MQISDPCH	handle = MQISDP_INV_CONN_HANDLE;
	int		rc = MQISDP_INV_MSG_HANDLE;

#line 1152 "lib/WebSphere/MQTT/Client.c"
	const char *	RETVAL;
	dXSTARG;

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    self = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"WebSphere::MQTT::Client::xs_getMsgStatus",
				"self");
		}
	} STMT_END
;
#line 778 "lib/WebSphere/MQTT/Client.xs"
  	/* get the connection handle */
  	handle = get_handle_from_hv( self );

	rc = MQIsdp_getMsgStatus( handle, hMsg );

	RETVAL = get_status_string(rc);

#line 1177 "lib/WebSphere/MQTT/Client.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_WebSphere__MQTT__Client); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_WebSphere__MQTT__Client)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("WebSphere::MQTT::Client::xs_version", XS_WebSphere__MQTT__Client_xs_version);
        newXS_deffile("WebSphere::MQTT::Client::xs_start_tasks", XS_WebSphere__MQTT__Client_xs_start_tasks);
        newXS_deffile("WebSphere::MQTT::Client::xs_status", XS_WebSphere__MQTT__Client_xs_status);
        newXS_deffile("WebSphere::MQTT::Client::xs_connect", XS_WebSphere__MQTT__Client_xs_connect);
        newXS_deffile("WebSphere::MQTT::Client::xs_disconnect", XS_WebSphere__MQTT__Client_xs_disconnect);
        newXS_deffile("WebSphere::MQTT::Client::xs_terminate", XS_WebSphere__MQTT__Client_xs_terminate);
        newXS_deffile("WebSphere::MQTT::Client::xs_subscribe", XS_WebSphere__MQTT__Client_xs_subscribe);
        newXS_deffile("WebSphere::MQTT::Client::xs_unsubscribe", XS_WebSphere__MQTT__Client_xs_unsubscribe);
        newXS_deffile("WebSphere::MQTT::Client::xs_receivePub", XS_WebSphere__MQTT__Client_xs_receivePub);
        newXS_deffile("WebSphere::MQTT::Client::xs_publish", XS_WebSphere__MQTT__Client_xs_publish);
        newXS_deffile("WebSphere::MQTT::Client::xs_getMsgStatus", XS_WebSphere__MQTT__Client_xs_getMsgStatus);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
